using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;

namespace WindowsApplication1
{
    [Serializable]
    class FrameInfo// : ISerializable
    {
        public FrameInfo()
        {
        }
        public static int StartFrame()
        {
            ms_frameInfos.Add(new FrameInfo());
            return ms_frameInfos.Count - 1;
        }
        public static FrameInfo GetCurrentFrameInfo()
        {
            return ms_frameInfos[ms_frameInfos.Count - 1] as FrameInfo;
        }

        public static void Save(Stream s, BinaryFormatter formatter)
        {
            formatter.Serialize(s, ms_frameInfos);
        }
        public static void Load(Stream s, BinaryFormatter formatter) //String fileName)
        {
            ms_frameInfos = formatter.Deserialize(s) as ArrayList;
        }

        public void AddAllocation(MemInfo info)
        {
            System.Diagnostics.Debug.Assert(info != null);
            m_blocksAllocated.Add(info);
        }
        public void AddFree(MemInfo info)
        {
            System.Diagnostics.Debug.Assert(info != null);
            m_blocksFreed.Add(info);
        }

        public static FrameInfo GetFrameInfo(int i)
        {
            return (FrameInfo)ms_frameInfos[i];
        }
        public static int GetNumFrameInfos()
        {
            return ms_frameInfos.Count;
        }

        public ArrayList m_blocksAllocated = new ArrayList();
        public ArrayList m_blocksFreed = new ArrayList();
        private static ArrayList ms_frameInfos = new ArrayList();
    }
}


