using System;
using System.Collections;
using System.Runtime.Serialization;

namespace WindowsApplication1
{
	/// <summary>
	/// Summary description for MemInfo.
	/// </summary>
    [Serializable]
	public class MemInfo
	{
		public MemInfo()
		{
		}

        public static void Clear()
        {
            ms_array.Clear();
            ms_allocatedBytes = 0;
            ms_allocatedBlocks = 0;
        }
		public static void Add(MemInfo info)
		{
			ms_array.Add(info);
			ms_allocatedBytes += info.m_bytes;
			++ms_allocatedBlocks;
		}

        public static MemInfo InfoForAddress(uint address)
        {
            foreach (MemInfo info in ms_array)
            {
                if (info.m_address == address)
                    return info;
            }
            return null;
        }
		public static bool Remove(uint address)
		{
			foreach (MemInfo info in ms_array)
			{
				if (info.m_address == address)
				{
					ms_array.Remove(info);
					ms_allocatedBytes -= info.m_bytes;
					--ms_allocatedBlocks;
					return true;
				}
			}
			return false;
		}

        /*public MemInfo(SerializationInfo info, StreamingContext ctx)
        {
            m_address = (uint)info.GetValue("Address", typeof(uint));
            m_bytes = (uint)info.GetValue("Bytes", typeof(uint));
            m_callStack = (uint[])info.GetValue("CallStack", typeof(uint[]));
            m_depth = (int)info.GetValue("Depth", typeof(int));
        }
        public void GetObjectData(SerializationInfo info, StreamingContext ctx)
        {
            info.AddValue("Address", m_address);
            info.AddValue("Bytes", m_bytes);
            info.AddValue("CallStack", m_callStack);
            info.AddValue("Depth", m_depth);
        }*/

		public uint				m_address;
		public uint				m_bytes;
		public uint[]			m_callStack = new uint[10];
        public int              m_depth = 0;

		static ArrayList	        ms_array = new ArrayList();
		public static uint			ms_allocatedBlocks = 0;
		public static uint			ms_allocatedBytes = 0;
	}
}
