#ifndef CORE_STACKTRACER_H
#define CORE_STACKTRACER_H

namespace rdecore 
{

namespace StackTrace
{
	typedef unsigned long	address_t;

	// @return: number of entries in the callstack.
	int GetCallStack(address_t* callStack, int maxDepth, int entriesToSkipAtStart = 0);

	void GetSymbolForAddress(address_t address, char* symbol, int maxSymbolLen);
	void GetFileLineForAddress(address_t address, char* file, int maxFileLen, int& line);

	void GetMainModuleInfo(char* outPdbName, int maxPdbNameLen, unsigned long& outModuleBase);

	void UnloadSymbols();
} // StackTrace

}

//-----------------------------------------------------------------------------
#endif // #ifndef CORE_STACKTRACER_H
