#ifndef CORE_SYSTEM_H
#define CORE_SYSTEM_H

//-----------------------------------------------------------------------------
// Include compiler/system specific file
//-----------------------------------------------------------------------------

// Determine what header should we include (detection based on compiler
// specific definitions -- http://predef.sourceforge.net/precomp.html).
//
// NOTE for developers: if you'd like to add support for another compiler
// to Reality Core then examine existing header files -- this should give
// you valuable hints.
//
// For the present the following compilers/platforms are supported:
//      * MS Visual C++
#if defined (_MSC_VER)
#	include "MSVC/Config.h"
#else
#	error "Compiler not supported!"
#endif


//-----------------------------------------------------------------------------
// Makes copy constructor+assignment operator private.
#define RDE_FORBID_COPY(CLASS)	\
	private: CLASS(const CLASS&); CLASS& operator=(const CLASS&)

//-----------------------------------------------------------------------------
#endif // !CORE_SYSTEM_H
