#include <UnitTest++/src/UnitTest++.h>
#include "../Integer.h"

namespace
{

TEST(BottomBit)
{
	CHECK_EQUAL(0ul, rdecore::Integer::BottomBit(0xFF));
	CHECK_EQUAL(8ul, rdecore::Integer::BottomBit(0xFF00));
}

TEST(TopBit)
{
	CHECK_EQUAL(8ul, rdecore::Integer::TopBit(0xFF));
	CHECK_EQUAL(16ul, rdecore::Integer::TopBit(0xFF00));
}

TEST(IsPowerOfTwo)
{
	CHECK(rdecore::Integer::IsPowerOfTwo(0));
	CHECK(rdecore::Integer::IsPowerOfTwo(1));
	CHECK(rdecore::Integer::IsPowerOfTwo(2));
	CHECK(rdecore::Integer::IsPowerOfTwo(4));
	CHECK(!rdecore::Integer::IsPowerOfTwo(5));
}

TEST(NextPowerOfTwo)
{
	CHECK_EQUAL(uint32_t(512), rdecore::Integer::NextPowerOfTwo(512));
	CHECK_EQUAL(uint32_t(512), rdecore::Integer::NextPowerOfTwo(511));
	CHECK_EQUAL(uint32_t(2048), rdecore::Integer::NextPowerOfTwo(1025));
	CHECK_EQUAL(uint32_t(1024), rdecore::Integer::NextPowerOfTwo(640));
}

TEST(Log2)
{
	CHECK_EQUAL(0ul, rdecore::Integer::Log2(1));
	CHECK_EQUAL(1ul, rdecore::Integer::Log2(2));
	CHECK_EQUAL(2ul, rdecore::Integer::Log2(4));
	CHECK_EQUAL(3ul, rdecore::Integer::Log2(8));

	for (uint32_t i = 4; i < 10; ++i)
	{
		CHECK_EQUAL(i, rdecore::Integer::Log2((1 << i)));
	}
}

} // namespace
