#include "Timer.h"
#include <windows.h>
#include <cassert>

namespace rdecore 
{
//-----------------------------------------------------------------------------
Timer::Timer()
{
	const BOOL success = ::QueryPerformanceFrequency(reinterpret_cast< LARGE_INTEGER* >(&m_frequency));
	assert(success);
	(void) success;
}

//-----------------------------------------------------------------------------
void Timer::Start()
{
	const BOOL success = ::QueryPerformanceCounter(reinterpret_cast< LARGE_INTEGER* >(&m_startTime));
	assert(success);
	(void) success;
}

//-----------------------------------------------------------------------------
int Timer::GetTimeInMs() const
{
	LARGE_INTEGER curTime;
	const BOOL success = ::QueryPerformanceCounter(&curTime);
	assert(success);
	(void) success;

	LARGE_INTEGER elapsedTime;
	elapsedTime.QuadPart = curTime.QuadPart - m_startTime;

	const double seconds = double(elapsedTime.QuadPart) / double(m_frequency);

	return int(seconds * 1000.0f);
}

}
//-----------------------------------------------------------------------------


